#include <idc.idc>		

// The script relocates a copy of the highest 64 KiB of a 512 KiB BIOS file to
// Segment: "F000:" for proper disassembly (adapted for use with IDA Pro 7).

static relocate_seg(src, dest)
{
	auto ea_src, ea_dest, hi_limit;
	
	hi_limit = src + 0x10000;
	ea_dest = dest;
	
	for(ea_src = src; ea_src < hi_limit ; ea_src = ea_src + 4 )
	{
	PatchDword( ea_dest, Dword(ea_src));
	ea_dest = ea_dest + 4;	
	}

  Message("Segment Relocation finished (inside relocate_seg function).\n");
}

static main()
{
  Message("Creating F000: Segment (inside main entry point function)...\n");
  SegCreate( (0xF000 << 4), (0x10000 << 4), 0xF000, 0, 0, 0);
  SegRename( (0xF000 << 4), "F000");

  relocate_seg( (0x7000 << 4), (0xF000 << 4) );
}

